<app-custom-scrollbar class="app-table">
  <!-- table header -->
  <div class="app-table-header ds mh">
    <!-- header row -->
    <div class="app-table-row">
      <!-- render columns -->
      <ng-container *ngFor="let item of columns">
        <!-- custom header -->
        <ng-container *ngIf="headerCells[item.property]; else defaultHeader">
          <ng-container
            *ngTemplateOutlet="headerCells[item.property].templateRef; context: { column: item }"
          ></ng-container>
        </ng-container>

        <!-- default header -->
        <ng-template #defaultHeader>
          <!-- column -->
          <div (click)="onSortableHeaderClicked(item)" [class.sortable]="item.useSort" class="app-table-column">
            {{ item.label }}

            <!-- sort icon -->
            <ng-container *ngIf="item.useSort">
              <!-- down icon -->
              <app-icon-arrow-drop-down *ngIf="item.direction === 'asc'; else desc"></app-icon-arrow-drop-down>

              <!-- up icon -->
              <ng-template #desc>
                <app-icon-arrow-drop-up></app-icon-arrow-drop-up>
              </ng-template>
            </ng-container>
          </div>
        </ng-template>
      </ng-container>
    </div>
  </div>

  <!-- loading -->
  <app-spinner *ngIf="loading; else body"></app-spinner>

  <!-- body template -->
  <ng-template #body>
    <!-- table body -->
    <div class="app-table-body">
      <!-- row -->
      <!-- render rows -->
      <div *ngFor="let item of rows" class="app-table-row">
        <!-- render columns -->
        <ng-container *ngFor="let column of columns">
          <!-- column -->
          <div class="app-table-column" *ngIf="column.property != 'permissions' || mobileHide">
            <!-- custom body -->
            <ng-container *ngIf="bodyCells[column.property]; else defaultBody">
              <ng-container
                *ngTemplateOutlet="
                  bodyCells[column.property].templateRef;
                  context: { column: column, row: item, value: item | tableRowData: column.property }
                "
              ></ng-container>
            </ng-container>

            <!-- default body -->
            <ng-template #defaultBody>
              {{ item | tableRowData: column.property }}
            </ng-template>
          </div>
        </ng-container>
      </div>
    </div>
  </ng-template>
</app-custom-scrollbar>

<!-- paginator -->
<div class="app-table-paginator ds mh">
  <!-- paginator -->
  <app-ellipsis-paginator
    (pagingChange)="emitPagingChange($event)"
    [page]="page"
    [size]="size"
    [total]="total"
  ></app-ellipsis-paginator>
</div>

<div class="load-more dh ms">
  <div>Loading more {{ loadLabel }}...</div>
</div>
